# Apache Flink 文档

本文档适用于Apache Flink 1.7版本。该内容构建于:2019-02-16。

Apache Flink是一个用于分布式流和批处理数据的开源平台。Flink的核心是一个流数据流引擎，它为数据流上的分布式计算提供数据分发、通信和容错功能。Flink在流引擎之上构建批处理、覆盖本地迭代支持、托管内存和程序优化。

## 第一步

*   **概念**: 从Flink的基本概念开始 [数据流编程模型](concepts/programming-model.html) 和 [分布式运行环境](concepts/runtime.html). 这将帮助您理解文档的其他部分，包括设置和编程指南。我们建议您先阅读这些部分。

*   **教程**:
    *   [实现并运行一个DataStream应用程序](./tutorials/datastream_api.html)
    *   [设置本地Flink集群](./tutorials/local_setup.html)
*   **编程指南**: 你可以阅读我们的指南 [API的基本概念](dev/api_concepts.html) 和 [DataStream API](dev/datastream_api.html) 或者 [DataSet API](dev/batch/index.html) 学习如何编写您的第一个Flink程序。

## 部署

在你的Flink作业投入生产之前, 阅读 [生产准备检查表](ops/production_ready.html).

## 发布说明

发布说明涵盖了Flink版本之间的重要更改。如果您打算将Flink设置升级到一个较新的版本，请仔细阅读这些说明。

*   [Flink 1.7 发布说明](release-notes/flink-1.7.html).
*   [Flink 1.6 发布说明](release-notes/flink-1.6.html).
*   [Flink 1.5 发布说明](release-notes/flink-1.5.html).

## 外部资源

*   **Flink 历程**: 过去会议的发言可在[Flink Forward](http://flink-forward.org/) 网站和 [YouTube](https://www.youtube.com/channel/UCY8_lgiZLZErZPF47a2hXMA). [Robust Stream Processing with Apache Flink](http://2016.flink-forward.org/kb_sessions/robust-stream-processing-with-apache-flink/) 这是认知Flink很好的起点.

*   **培训**:  在[training materials](http://training.data-artisans.com/) 该链接提供教案、实例联系、示例解决方案；

*   **博客**: 在 [Apache Flink](https://flink.apache.org/blog/) 和 [data Artisans](https://data-artisans.com/blog/) 经常发布滚鱼Flink的深入技术文章。
